;;;
;;;11/12/94
;;;By John M. Anderson
;;;Compuserve Id# 72137,67
;;;P.O. Box 7361, Tahoe City, Ca. 96145
;;;(916) 581-3644
;;;(c)1994 John M. Anderson  
;;;          
;;;***This is a text editer for editing ALL Autocad text entities
;;;***from a single lisp routine.
;;;***Pick on attribute for single edit & on block to edit all
;;;***of the block's attributes.
;;;***Uses DDEDIT for Attdefs & DDATTE for attribute lists
;;;
;;;LOCAL FUNCTIONS 
;;;Get Entity Type -I load this elsewhere for global access.
(defun entx (pik)
     (setq ent (car pik))
     (setq elist (entget ent))
     (setq etype (cdr (assoc 0 elist)))
     (if (= (type (car (last pik))) 'ename)
         (progn
               (setq entblk (car (last pik)))
               (setq elistblk (entget  entblk))
               (setq etypeblk (cdr (assoc 0 elistblk)))
         )
         (progn
               (setq entblk nil)
               (setq elistblk nil)
               (setq etypeblk nil)
         )
     ) 
)
;;;Call Dialog
(defun edtxt (old titl)
     (setq dcl_id (load_dialog "et.dcl"))
     (if (not (new_dialog "text_edit" dcl_id)) (exit))
     (set_tile "text" old)
     (if titl
          (set_tile "box" titl)
     )
     (action_tile "text" "(setq new $value)" )
     (action_tile "accept" "(done_dialog 1)" )
     (if (equal (start_dialog) 1)
         nil
         (setq new new)
     )
     (unload_dialog dcl_id)
     new
)
;;;
;;;
;;;MAIN FUNCTION
(defun c:et ( ;/ old               current value
                 ;new               new value
                 ;rep               new list with new value
             );                     end local variable list
     (while (setq ent (nentsel))
          (entx ent)
          (cond ((or (= etype "ATTRIB")
                     (= etype "TEXT")
                 ) 
                 (progn
                      (setq labl (cond ((= etype "ATTRIB")
                                        "Attribute Text"
                                       )
                                       ((= etype "TEXT") (cond ((= etypeblk "DIMENSION")
                                                                "Dimension Text"
                                                               )
                                                               ((= etypeblk "INSERT")
                                                                "Nested text"
                                                               )
                                                               (T "Text") 
                                                          )
                                       )
                                 ); end cond
                            old (cdr (assoc 1 elist))
                            new (edtxt old labl)
                            rep (if new
                                    (subst (cons 1 new) (assoc 1 elist) elist)
                                ); end if -value replaced 
                      );            end setq
                      (entmod rep)
                      (if (or (= etypeblk "DIMENSION")
                              (= etypeblk "INSERT")
                          ) 
                          (entupd (cdr (assoc -1 elistblk)))
                          (entupd (cdr (assoc -1 elist)))
                      )
                 );                 end progn
                );                  end cond
               ((= etype "ATTDEF")
                (command "ddedit" ent "")
               )
               ((and (/= etype "TEXT")
                     (= etypeblk "INSERT")
                     (member '(66 . 1) elistblk)
                )
                (command "ddatte" entblk)
                )
          ); close cond
     );      end while
     (princ)
);           end defun
